<?php

/* A plugin to use WP-reCAPTCHA in Contact Form 7.
 * This class needs WP-reCAPTCHA and Contact Form 7 plugin installed and activated.
 * http://wordpress.org/extend/plugins/wp-recaptcha/
 * http://wordpress.org/extend/plugins/contact-form-7/
 */



require_once('WPASDPlugin.class.php');

	//add_filter( 'cf7recaptcha_validate_recaptcha', 'cf7recaptcha_validation_filter', 10, 2 );


if (!class_exists('CF7reCAPTCHA')) {

    class CF7reCAPTCHA extends WPASDPlugin {
    
	const recaptcha_options_name = 'recaptcha_options';
	
    
	// member variables
	private $is_useable;
	
	
	// php4 Constructor
	function CF7reCAPTCHA($options_name) {
	    
	    $args = func_get_args();
	    call_user_func_array(array(&$this, "__construct"), $args);
	}
	
	
	// php5 Constructor
	function __construct($options_name) {
	    parent::__construct($options_name);
	    
	}
	
	
	function pre_init() {
	
	    $this->register_default_options();
	    
	    // require the libraries
	    $this->require_library();
	    
	}
	
	function post_init() {
	
	    // register CF7 hooks
	    $this->register_cf7();
	    
	}
	
	// set the default options
	function register_default_options() {
	
	    if ($this->options)
		return;
		
	    $default_options = array();
	    
	    // example
	    // $default_options['option_name'] = 'value';
	    
	    
	    // add the options based on the environment
	    WPASDPlugin::add_options($this->options_name, $default_options);
	}
	
	function require_library() {
	    
	}
	
	function register_actions() {
	    global $wp_version;
	
	    // global configuration
	    /**
	    if ( version_compare( $wp_version, '2.7alpha', '>' ) ) {
		add_action( 'after_plugin_row_' . CF7RECAP_BASENAME, array(&$this, 'add_config_form' ), 10, 3 );		
	    } else {
	        add_action( 'after_plugin_row', array(&$this, 'add_config_form' ), 10, 3 );
	    }*/
	
	
	    add_action( 'admin_notices', array(&$this, 'admin_notice') );
	    
	    
	    if ($this->useable()) {
	
		add_action( 'admin_init', array(&$this, 'tag_generator_recaptcha'), 46 );
		//add_action( 'admin_footer', array(&$this, 'add_script2admin_footer') );
	    
	    }
	
	}
	
	
	function register_filters() {
	
	
	    /**
	    if ( version_compare( $wp_version, '2.7alpha', '>' ) ) {
		add_filter( 'plugin_action_links_' . CF7RECAP_BASENAME, array(&$this, 'add_settings_link'), 10, 2 );
		
	    } else {
	        add_filter( 'plugin_action_links', array(&$this, 'add_settings_link'), 10, 2 );
	    }*/
	
	    if ( $this->useable() ) {
	    
		add_filter( 'wpcf7_validate_recaptcha', array(&$this, 'recaptcha_validation_filter'), 10, 2 );
		
		add_filter( 'wpcf7_ajax_json_echo', array(&$this, 'ajax_json_echo_filter') );
		
	    }

		
	}
	
	function register_cf7() {
	
	    // CF7 Shortcode Handler
	    if (function_exists('wpcf7_add_shortcode') && $this->useable() ) {
	    
		wpcf7_add_shortcode( 'recaptcha', array(&$this, 'shortcode_handler'), true );	
		
	    }
	    
		
	}
	
	
	function useable() {
	    if (!isset($this->is_useable)) {
		$this->is_useable = $this->is_recaptcha_active() && $this->is_cf7_active();
	    }
		
	    return $this->is_useable;
	}
    
	function is_recaptcha_active() {
	
	    return in_array( 
		'wp-recaptcha/wp-recaptcha.php', 
		apply_filters( 
		    'active_plugins', 
		    get_option( 
			'active_plugins' ) ) );
	
	}
	
	function is_cf7_active() {
	    return in_array( 
		'contact-form-7/wp-contact-form-7.php', 
		apply_filters( 
		    'active_plugins', 
		    get_option( 
			'active_plugins' ) ) );
	}
	
	/**
	function add_settings_link( $links, $file ) {
	    
	    array_unshift(
		$links,
		sprintf( '<a id="cf7recap-pluginconflink" href="javascript:void(0)" title="Configure this plugin">%s</a>', __('Settings') )
		);
		
	    return $links;
	}*/
	
	/**
	function add_script2admin_footer() {
	    
	    ?>
	    <script type="text/javascript">
		jQuery(document).ready(
	    </script>
	    <?php
	
	
	}*/
	
	/**
	 * 
	 * @return
	 * @param $wm_pluginfile Object
	 * @param $wm_plugindata Object (array)
	 * @param $wm_context    Object (all, active, inactive)
	 */
	/**function add_config_form($cf7_pluginfile, $cf7_plugindata, $cf7_context) {

	    $config_visibility = 'class="';
	    if ( !isset($_GET['show']) || 'cf7config' != $_GET['show']) {
	     
		$config_visibility .= 'config_hidden' ;
	    }
	    $config_visibility .= '"';
	    
	    ?>
	    <tr id="cf7_config_tr">
		<td colspan="3">
		
		    <div id="cf7_config_row" <?php echo $config_visibility; ?>>
			<p> test </p>
		    </div>		
		</td>
	    </tr>
	    <?php 
	    
	}*/
	
	
	function ajax_json_echo_filter( $items ) {
	    if ( ! is_array( $items['onSubmit'] ) )
		$items['onSubmit'] = array();

	    $items['onSubmit'][] = 'Recaptcha.reload();';

	    return $items;
	}


	function recaptcha_validation_filter( $result, $tag ) {
	    global $recaptcha;
	    
	    $name = $tag['name'];
	    
	    if(!$this->is_multi_blog()) {
		
		$errors = new WP_Error();
		
		$recaptcha->validate_recaptcha_response($errors);
		
		$error_list = $errors->get_error_messages(null);
		
		if (!empty($error_list)) {
		
		    $result['valid'] = false;
		    
		    $error_out = "";
		    
		    foreach ($error_list as $value) {
		    
			$error_out .= $value;	
			
		    }
		    
		    $result['reason'][$name] = $error_out;
		}
		
	    } else {
	    
	        $recaptcha->validate_recaptcha_response_wpmu($result);
		
	    }
	

	    return $result;
	}
	
	
	function tag_generator_recaptcha() {
	
	    if (function_exists('wpcf7_add_tag_generator') && $this->useable()) {
		wpcf7_add_tag_generator(
		    'recaptcha',
		    __( 'reCAPTCHA', 'cf7recaptcha'),
		    'cf7recaptcha-tg-pane',
		    array(&$this, 'tag_pane'));
	    }
	    
	}

	
	function shortcode_handler( $tag ) {
	    global $wpcf7_contact_form, $recaptcha;

	    $name = $tag['name'];
	    
	    $recaptcha_options = WPASDPlugin::retrieve_options(CF7reCAPTCHA::recaptcha_options_name);
	    
	    $js_options = <<<OPTS
	    <script type='text/javascript'>
		var RecaptchaOptions = { theme : '{$recaptcha_options['comments_theme']}', lang : '{$recaptcha_options['recaptcha_language']}'};
	    </script>
OPTS;

	    $use_ssl = isset( $_SERVER['HTTPS'] ) && $_SERVER['HTTPS'] == 'on';


	    $html = $js_options . $recaptcha->get_recaptcha_html( null, $use_ssl );

	    $validation_error = '';
	    if ( is_a( $wpcf7_contact_form, 'WPCF7_ContactForm' ) )
		$validation_error = $wpcf7_contact_form->validation_error( $name );
	
	    //$html .= '<div id="recaptcha-submit-btn-area"></div>';
	    $html .= '<span class="wpcf7-form-control-wrap ' . $name . '">' . $validation_error . '</span>';

	    return $html;
	}


	function tag_pane( &$contact_form ) {
?>
<div id="cf7recaptcha-tg-pane" class="hidden">
<form action="">
<table>

<?php if ( ! $this->useable() ) : ?>
<tr><td colspan="2"><strong style="color: #e6255b">you need reCAPTCHA</strong><br /></td></tr>
<?php endif; ?>

<tr><td><?php echo esc_html( __( 'Name', 'cf7recaptcha' ) ); ?><br /><input type="text" name="name" class="tg-name oneline" /></td><td></td></tr>
</table>

<div class="tg-tag"><?php echo esc_html( __( "Copy this code and paste it into the form left.", 'cf7recaptcha' ) ); ?>
<br />
<input type="text" name="recaptcha" class="tag" readonly="readonly" onfocus="this.select()" />
</div>
</form>
</div>
<?php
	}	
	
	
	function admin_notice() {
	    global $plugin_page;

    	    //if ( ! isset( $plugin_page ) || 0 !== strpos( $plugin_page, WPCF7_PLUGIN_NAME ) )
	    //	return;

	    if ( ! $this->is_cf7_active() ) :

?>
<div id="message" class="updated fade"><p><?php echo esc_html( __( "You are using Contact Form 7 reCAPTCHA Extension. This works with the Contact Form 7 plugin, but the Contact Form 7 plugin is not activated.", 'cf7recaptcha' ) ); ?>
 &mdash; Contact Form 7 <a href="http://wordpress.org/extend/plugins/contact-form-7/">http://wordpress.org/extend/plugins/contact-form-7/</a><p>
</div>
<?php
	    endif;


	    if ( ! $this->is_recaptcha_active() ) :

?>
<div id="message" class="updated fade"><p><?php echo esc_html( __( "You are using Contact Form 7 reCAPTCHA Extension. This works with the WP-reCAPTCHA plugin, but the WP-reCAPTCHA plugin is not activated.", 'cf7recaptcha' ) ); ?>
 &mdash; WP-reCAPTCHA <a href="http://wordpress.org/extend/plugins/wp-recaptcha/">http://wordpress.org/extend/plugins/wp-recaptcha/</a><p>
</div>
<?php
	    endif;


	    
	    
	}
    
    }

}

?>